---
title: void operator
slug: Web/JavaScript/Reference/Operators/void
tags:
  - JavaScript
  - Language feature
  - Operator
  - Reference
  - Unary
---
<div>{{jsSidebar("Operators")}}</div>

<p>The <strong><code>void</code> operator</strong> evaluates the given <code><em>expression</em></code> and then returns {{jsxref("undefined")}}.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-voidoperator.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">void <em>expression</em></pre>

<h2 id="Description">Description</h2>

<p>This operator allows evaluating expressions that produce a value into places where an expression that evaluates to {{jsxref("undefined")}} is desired.</p>

<p>The <code>void</code> operator is often used merely to obtain the <code>undefined</code> primitive value, usually using "<code>void(0)</code>" (which is equivalent to "<code>void 0</code>"). In these cases, the global variable {{jsxref("undefined")}} can be used.</p>

<p>It should be noted that <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Operator_Precedence">the precedence</a> of the <code>void</code> operator should be taken into account and that parentheses can help clarify the resolution of the expression following the <code>void</code> operator:</p>

<pre class="brush: js notranslate">void 2 == '2';   // (void 2) == '2', returns false
void (2 == '2'); // void (2 == '2'), returns undefined
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Immediately_Invoked_Function_Expressions">Immediately Invoked Function Expressions</h3>

<p>When using an <a href="/en-US/docs/Glossary/IIFE">immediately-invoked function expression</a>, <code>void</code> can be used to force the <code>function</code> keyword to be treated as an expression instead of a declaration.</p>

<pre class="brush: js notranslate">void function iife() {

  console.log("Executed!");

}();

// Output: "Executed!"
</pre>

<p>Executing the above function without the <code>void</code> keyword will result in an <strong>Uncaught SyntaxError</strong>.</p>

<h3 id="JavaScript_URIs">JavaScript URIs</h3>

<p>When a browser follows a <code>javascript:</code> URI, it evaluates the code in the URI and then replaces the contents of the page with the returned value, unless the returned value is {{jsxref("undefined")}}. The <code>void</code> operator can be used to return <code>undefined</code>. For example:</p>

<pre class="brush: html notranslate">&lt;a href="javascript:void(0);"&gt;
  Click here to do nothing
&lt;/a&gt;

&lt;a href="javascript:void(document.body.style.backgroundColor='green');"&gt;
  Click here for green background
&lt;/a&gt;
</pre>

<div class="notecard note">
<p><strong>Note</strong>: <code>javascript:</code> pseudo protocol is discouraged over other alternatives, such as unobtrusive event handlers.</p>
</div>

<h3 id="Non-leaking_Arrow_Functions">Non-leaking Arrow Functions</h3>

<p>Arrow functions introduce a short-hand braceless syntax that returns an expression. This can cause unintended side effects by returning the result of a function call that previously returned nothing. To be safe, when the return value of a function is not intended to be used, it can be passed to the void operator to ensure that (for example) changing APIs do not cause arrow functions' behaviors to change.</p>

<pre class="brush: js notranslate">button.onclick = () =&gt; void doSomething();</pre>

<p>This ensures the return value of <code>doSomething</code> changing from <code>undefined</code> to <code>true</code> will not change the behavior of this code.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-void-operator', 'The void Operator')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.void")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("undefined")}}</li>
</ul>
